//      AVR
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h> 

#define F_CPU 8000000UL

//   2 
//     
unsigned char cw_dir[8]= 
{
0b00000001,
0b00000011,
0b00000010,
0b00000110,
0b00000100,
0b00001100,
0b00001000,
0b00001001
};

//     
unsigned char ccw_dir[8]= 
{
0b00001001,
0b00001000,
0b00001100,
0b00000100,
0b00000110,
0b00000010,
0b00000011,
0b00000001
};

volatile unsigned char step_index;
volatile unsigned int ovftimes;
volatile unsigned char status;

//    0
ISR(TIMER0_OVF_vect)
{
static unsigned int count = 1;
count++;
if(count >= ovftimes) //  
{

cli(); //  


switch (status)//  
{  
case 0:
PORTB = cw_dir[step_index++]; //   
PORTD = 0b11101111; //  :  D4 - "0",  D5 - "1"
break;

case 1:
PORTB = ccw_dir[step_index++]; //   
PORTD = 0b11101111; //  :  D4 - "0",  D5 - "1"
break; 

case 2:
PORTB = 0x00; // .    -  
PORTD = 0b11011111; //  :  D4 - "1",  D5 - "0"
break;     
}

//if(status) //  status == 1   
//PORTB = ccw_dir[step_index++];

//else       //    
//PORTB = cw_dir[step_index++];


if (step_index >= 8)
step_index=0;

count = 0; //  
TCNT0 = 0; //    
sei(); //   
}
}

// ---------   ------------------

int main(void)
{
DDRB = 0b00001111; // PB0, PB1, PB2, PB3 - 
PORTB = 0x00; // .   

DDRD = 0b11110000; // PD0...PD3 - , PD4...PD7 - 
PORTD = 0b11011111; //  :  D4 - "1",  D5 - "0"
status = 2;

ADCSRA = (1 << ADEN) //  
      | (1 << ADPS2) //   64 (  125kHz)
	  | (1 << ADPS1);
ADMUX = 0x00; // ADC0 - ,   5 

TCCR0 |= (1 << CS01); //   8
TCNT0 = 0; //    

step_index = 0;
ovftimes = 10; //  

sei(); //   


while(1) // -----------   -----------

{
ADCSRA |= (1 << ADSC); //  

while (ADCSRA & (1 << ADSC)); //    
ovftimes = ADCW; //   


if((PIND &(1 << PD2)) == 0)//   SB1

	{
TIMSK |= (1 << TOIE0); //    
status = 1;
	}
else 
	{
TIMSK &= ~(1 << TOIE0); //    
status = 2;
	}

if((PIND &(1 << PD3)) == 0)//   SB2

	{
TIMSK |= (1 << TOIE0); //    
status = 0;
	}
else 
	{
TIMSK &= ~(1 << TOIE0); //    
status = 2;
	}
  }
}

